#!/usr/local/bin/perl -w

# Vi anropar vr subrutin
# "." betyder aktuell katalog
# man kan istllet skriva ett namn p en katalog
recursive(".");

# Navigerar genom en katalogstruktur
sub recursive {
   # tar emot ett namn p en katalog
   local($dir) = @_;
   # talar om att vi vill bearbeta denna katalog
   &searchdir($dir);
   # och i den vill vi bearbeta varje underkatalog
   foreach $dir (<*>) {
      # -d betyder att vi kollar ifall det vi frsker bearbeta r en katalog
      if(-d $dir) {
         # i s fall gr vi ner i den katalogen
         chdir($dir);
         # och s frsker vi g ner i eventuella kataloger i den
         &recursive($dir);
         # nr vi gtt igenom alla gr vi upp igen
         chdir("..");
         # plocka bort senaste katalogens namn frn $reldir
         chop($reldir);
         while($reldir =~ /[^\/]$/) {
            $reldir =~ s/[^\/]$//;
         }
      }
   }
}

# G igenom den aktuella katalogen
# och bearbeta varje fil
sub searchdir {
   # tar emot ett namn p en katalog
   local($dir)=@_;
   # lgger till katalognamnet till $reldir
   $reldir .= "$dir/";
   # tar bort eventuellt '/' i slutet av $reldir
   while($reldir =~ /^[.\/]/) { $reldir =~ s/^[.\/]//; }
   # ppna den aktuella katalogen
   opendir(DIR,".") || die ("Can't open "."\n");
   # lser in namnen p alla filer i katalogen till en lista
   @files = readdir(DIR);
   # stnger katalogen
   close(DIR);
   # skriver ut skvgen till den katalog vi befinner oss i
   print "$reldir\n";
   # fr varje fil i katalogen
   foreach $file (@files) {
      unless(-d $file) {
         # skriver vi ut dess namn
         print "$file ";
      }
   }
   # och lite luft
   print "\n\n";
}
